package fi.jyu.mit.barChart;

import java.awt.Color;
import java.awt.Graphics;

import fi.jyu.mit.graphics.*;

/**
 * Luokka pylvsdiagrammin pylville. Ktetn yhdess BarChart-luokan kanssa.
 * @author Markus Kivioja
 * @version 25.05.2009
 */
public class Bar extends FillPolygon {

    private int x;
    private double width;
    private double value;


    /**
     * Luo uuden pylvn.
     * @param x Pylvn paikka diagrammissa.
     * @param width pykvn leveys
     * @param height Pylvn korkeus.
     */
    public Bar(int x, double width, double height) {
        super();
        this.x = x;
        this.width = width;
        this.value = height;
        this.count = 4;
        this.initialize();
        this.ps[0] = new RPoint(x, 0);
        this.ps[1] = new RPoint(x, height);
        this.ps[2] = new RPoint(x + width, height);
        this.ps[3] = new RPoint(x + width, 0);
    }


    /**
     * Asettaa pylvn paikan diagrammissa
     * @param x pylvn paikka diagrammissa
     */
    public void setX(int x) {
        this.x = x;
        this.ps[0].set(x, 0);
        this.ps[1].set(x, value);
        this.ps[2].set(x + width, value);
        this.ps[3].set(x + width, 0);
        this.redraw();
    }


    /**
     * Asettaa pylvn korkeuden
     * @param value spylvn korkeus
     */
    public void setValue(double value) {
        this.value = value;
        this.ps[1].set((double) x, value);
        this.ps[2].set(x + width, value);
        this.redraw();
    }


    /**
     * Antaa pylvn paikan diagrammissa
     * @return pylvn paikka diagrammissa
     */
    public int getX() {
        return this.x;
    }


    /**
     * Antaa pylvn korkeuden
     * @return pylvn korkeus
     */
    public double getValue() {
        return this.value;
    }


    @Override
    protected void drawShape(Graphics g, Matrix a) {
        super.drawShape(g, a);
        g.setColor(Color.BLACK);
        super.drawEmpty(g, a);
    }
}
