package fi.jyu.mit.barChart;

import java.awt.AWTEventMulticaster;
import java.util.EventListener;

/**
 * Luokka useita BarListener-tapahtumakuuntelijoita varten
 * @author Markus Kivioja
 * @version 25.05.09
 */
public class BarEventMulticaster extends AWTEventMulticaster
        implements BarListener {

    protected BarEventMulticaster(EventListener a, EventListener b) {
        super(a, b);
    }


    /**
     * @param a
     * @param b
     * @return listty kuuntelija
     */
    public static BarListener add(BarListener a, BarListener b) {
        return (BarListener) addInternal(a, b);
    }


    /**
     * @param l 
     * @param oldl
     * @return poistettu
     */
    public static BarListener remove(BarListener l, BarListener oldl) {
        return (BarListener) removeInternal(l, oldl);
    }


    @Override
    public void barClicked(BarEvent e) {
        if (a != null)
            ((BarListener) a).barClicked(e);
        if (b != null)
            ((BarListener) b).barClicked(e);
    }


    protected static EventListener addInternal(EventListener a,
            EventListener b) {
        if (a == null)
            return b;
        if (b == null)
            return a;
        return new BarEventMulticaster(a, b);
    }


    @Override
    protected EventListener remove(EventListener oldl) {
        if (oldl == a)
            return b;
        if (oldl == b)
            return a;
        EventListener a2 = removeInternal(a, oldl);
        EventListener b2 = removeInternal(b, oldl);
        if (a2 == a && b2 == b)
            return this;
        return addInternal(a2, b2);
    }
}
