package fi.jyu.mit.graphics;

/**
 * Kolmiulotteinen piste
 * @author Markus Kivioja
 *
 */
public class RPoint extends Vector {

    /**
     * Luo uuden pisteen
     *
     */
    public RPoint() {
        super();
    }


    /**
     * Luo uuden pisteen annetuilla x- ja y-koordinaateilla ja z-koordinaatti on nolla
     * @param x x-koordinaatti
     * @param y y-koordinaatti
     */
    public RPoint(double x, double y) {
        super(x, y, 0.0);
    }


    /**
     * Luo uuden pisteen annetuilla x-, y- ja x-koordinaateilla
     * @param x x-koordinaatti
     * @param y y-koordinaatti
     * @param z z-koordinaatti
     */
    public RPoint(double x, double y, double z) {
        super(x, y, z);
    }


    public void setPoint(double x, double y, double z) {
        set(0, x);
        set(1, y);
        set(2, z);
    }


    /**
     * Antaa tmn pisteen x-koordinaatin
     * @return pisteen x-koordinaatti
     */
    public double getX() {
        return a(0);
    }


    /**
     * Antaa tmn pisteen y-koordinaatin
     * @return pisteen y-koordinaatti
     */
    public double getY() {
        return a(1);
    }


    /**
     * Antaa tmn pisteen z-koordinaatin
     * @return pisteen z-koordinaatti
     */
    public double getZ() {
        return a(2);
    }


    /**
     * Uusi piste, joka on summa tst ja p:st
     * @param p piste joka listn
     * @return uusi summapiste
     */
    public RPoint sum(RPoint p) {
        return sum(p.getX(), p.getY(), p.getZ());
    }


    /**
     * Uusi piste, joka on summa tst ja p:st
     * @param x listtvn pisteen x-koordinaatti
     * @param y listtvn pisteen y-koordinaatti
     * @param z listtvn pisteen z-koordinaatti
     * @return uusi summapiste
     */
    public RPoint sum(double x, double y, double z) {
        RPoint r = new RPoint(getX() + x, getY() + y, getZ() + z);
        return r;
    }


    /**
     * Uusi piste, joka on summa tst ja p:st
     * @param x listtvn pisteen x-koordinaatti
     * @param y listtvn pisteen y-koordinaatti
     * @return uusi summapiste
     */
    public RPoint sum(double x, double y) {
        return sum(x, y, 0);
    }

}
