package fi.jyu.mit.graphics;

/**
 * Kaksiulotteinen kokonaislukupiste
 * @author Markus Kivioja
 *
 */
public class SPoint {

    private int x;
    private int y;


    /**
     * Luo uuden pisteen
     * @param x pisteen x-koordinaatti
     * @param y pisteen y-koordinaatti
     */
    public SPoint(int x, int y) {
        this.x = x;
        this.y = y;
    }


    /**
     * Antaa pisteen x-koordinaatin
     * @return pisteen x-koordinaatti
     */
    public int getX() {
        return this.x;
    }


    /**
     * Antaa pisteen y-koordinaatin
     * @return pisteen y-koordinaatti
     */
    public int getY() {
        return this.y;
    }


    /**
     * Asettaa pisteelle uudet koordinaatit
     * @param x uusi x-koordinaatti
     * @param y uusi y-koordinaatti
     * @return tm piste muutoksen jlkeen
     */
    public SPoint set(int x, int y) {
        this.x = x;
        this.y = y;
        return this;
    }
}
