package fi.jyu.mit.graphics;

import java.awt.Container;
import java.awt.event.ActionListener;

import javax.swing.*;

/**
 * Painike johon voi liitt muunnosmatriisin
 * @author Markus Kivioja
 *
 */
public class TransformButton extends JButton {

    private static final long serialVersionUID = 1L;

    private Matrix tM;


    /**
     * Luo uuden painikkeen
     * @param text painikkeen teksti
     */
    public TransformButton(String text) {
        super(text);
    }


    /**
     * Asettaa muunnosmatriisin thn painikkeeseen
     * @param pM asetettava muunnosmatriisi
     */
    public void setTransform(Matrix pM) {
        this.tM = pM;
    }


    /**
     * Antaa tmn painikkeen muunnosmatriisin
     * @return tmn painikkeen muunnosmatriisi
     */
    public Matrix getTransform() {
        return this.tM;
    }


    /**
     * Metodi helpottamaan komponentin luontia
     * @param pM asetettava muunnosmatriisi
     * @param parent painikkeen vanhempi
     * @param constraints rajoitteet nappulalle
     * @param listener painikkeen tapahtumakuuntelija
     * @return this object
     */
    public TransformButton set(Matrix pM, Container parent, Object constraints,
            ActionListener listener) {
        setTransform(pM);
        if (parent != null)
            parent.add(this, constraints);
        addActionListener(listener);
        return this;
    }

}
