package sample;

import fi.jyu.mit.graphics.*;
import static java.lang.Math.*;

/**
 * Esimerkki 3D-pinnan piirtmisest.
 * Esimerkki mys miten pit kirjoittaa, jotta samasta koodista saa 
 * helposti sek sovelluksen ett sovelman (Applet)
 * @author vesal
 */
public class FunctionR2ASample {

    /**
     * Luokka sin*cos-funktion ksittelemiseksi.
     */
    public static class SinCos implements FunctionR2R {
        /**
         * Luodaan stattinen sini-funktio kaikkien kyttn.
         */
        public static final FunctionR2R sincos = new SinCos(); // NOPMD nimi saa
                                                               // kelvata


        /**
         * sin*cos-funktion arvo pisteess x 
         * @param x mista arvo lasketaan
         * @param y mista arvo lasketaan
         * @return sin(x)*cos(y) 
         */
        @Override
        public double f(double x, double y) { // NOPMD, nyt f on hyva nimi
            return sin(x) * cos(y);
        }
    }


    /**
     * ALutetaan paneeli niin, ett alsustus kelpaa Window-luokalle ja EasyApplet-luokalle
     * @param panel paneli joka laustetaan
     * @return panel
     */
    public static SpacePanel initPanel(SpacePanel panel) {
        panel.scale(-9, -9, 9, 9);
        panel.add(new Axis(15, 15, 15));
        panel.add(new FunctionMapR2R(SinCos.sincos, -2 * PI, -2 * PI, 2 * PI,
                2 * PI));
        panel.rotate(Axis.X, 50);
        panel.rotate(Axis.Y, 20);
        return panel;
    }


    /**
     * Pohjelma sovellusta varten
     * @param args ei kytss
     */
    public static void main(String[] args) {
        Window window = new Window();
        initPanel(window.getPanel());
        window.showWindow();
        // new Rotator(window,Axis.Z,5,50);
        window.setTouchPad(true, true);
        window.setControlButtons(true);

    }

    /**
     * Applet luokka samasta asiasta.  Tm pit ajaa
     * applettina nimell FunctionR2ASample$Applet
     * TODO: Onko tuo em. oikein? 
     */
    public static class Applet extends EasyApplet {
        private static final long serialVersionUID = 8729837737198762878L;


        /**
         * Alustetaan Apletin yleiset tiedot luomalla
         * "ohjainlevy" ja ohjainnappulat.
         * @see fi.jyu.mit.graphics.EasyApplet#init()
         */
        @Override
        public void init() {
            this.setTouchPad(true, true);
            this.setControlButtons(true);
            initPanel(getPanel());
        }
    }

}
