package sample;

import java.awt.Color;

import fi.jyu.mit.graphics.*;

/**
 * Esimerkiss piirretn peruskuvioita ja nytetn
 * niit kahdesta eri ikkunasta. 
 * @author vesal
 */
public class GraphicsSample {

    /**
     * Piirretn kuvioita ja nytetn niit kahdesta eri ikkunasta.
     * @param args
     */
    public static void main(String[] args) {

        EasySpace space = new EasySpace(); // Luodaan avaruus johon lisataan
                                           // komponentit

        double points[][] = { { 0, -2, 1 }, { 2, -2, 2 }, { 2, 0, 3 },
                { 0, 2, 2 }, { -2, 0, 1 } };

        space.addPolygon(points).setColor(255, 0, 0); // 3D-polygon

        space.addCircle(0, 0, 2).setColor(0, 255, 0);

        space.addLine(-2.7, 2.5, 1, 1).setColor(0, 0, 255);

        space.addCircle(0, -2.5, 0.2);

        double tr[][] = { { 1, 1 }, { 1, 2 }, { 2, 1 } };
        space.add(new FillPolygon(tr)).setColor(Color.YELLOW);

        Window window = new Window();
        window.scale(-3, -3, 3, 3);
        space.addAxis(5, 5, 5); // x-, y- ja z-akselit joiden pituus on 5

        window.setSpace(space); // Asetetaan window-ikkuna nayttamaan aiemmin
                                // luotua spacea

        window.showWindow();

        EasyWindow w2 = new EasyWindow(400, 400);
        w2.scale(-5, -5, 5, 5);

        w2.rotate(Axis.Y, 45); // Pyoritetaan y-akselin ympari
        w2.rotate(Axis.Z, 45); // Pyoritetaan z-akselin ympari

        w2.setSpace(space);
        w2.showWindow();
        w2.getPanel().setAllowRescale(false);

        space.addCircle(0, 0, -3, 1).setColor(192, 52, 200);
    }
}
