package fi.jyu.mit.graphics;

import java.awt.*;

/**
 * Olioiden ohjaimien yliluokka
 * @author Markus Kivioja
 *
 */
public class BasicController extends Container implements ObjectController {

    private static final long serialVersionUID = 1L;
    private Transformable objectToControl;


    /**
     * Luo uuden ohjaimen
     * @param objectToControl olio jota tll ohjaimella ohjataan
     */
    public BasicController(Transformable objectToControl) {
        super();
        this.objectToControl = objectToControl;
        this.setBounds(0, 0, 150, 150);
        setLayout(new BorderLayout());
    }


    @Override
    public void setObject(Transformable object) {
        this.objectToControl = object;
    }


    @Override
    public Transformable getObject() {
        return objectToControl;
    }


    @Override
    public void showController() {
        this.setVisible(true);
    }


    @Override
    public void hideController() {
        this.setVisible(false);
    }

}
