package fi.jyu.mit.graphics;

import java.awt.BorderLayout;

import javax.swing.JFrame;

/**
 * Frame olioiden ohjaimille
 * @author Vesa Lappalainen
 * @author Markus Kivioja
 */
public class ControllerFrame extends JFrame implements ObjectController {

    private static final long serialVersionUID = 1L;

    private BasicController controller;


    /**
     * Luo uuden framen olioiden ohjaimelle
     * @param controller ohjain joka asetetaan t�h�n frameen
     */
    public ControllerFrame(BasicController controller) {
        super();
        this.controller = controller;
        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(controller);
    }


    /**
     * Luo uuden framen olioiden ohjaimelle
     * @param controller ohjain joka asetetaan t�h�n frameen
     * @param x framen paikan x-koordinaatti
     * @param y framen paikan y-koordinaatti
     * @param w framen leveys
     * @param h framen korkeus
     */
    public ControllerFrame(BasicController controller, int x, int y, int w,
            int h) {
        this(controller);
        setBounds(x, y, w, h);
        showController();
    }


    /**
     * @return liitetty controlleri
     */
    public BasicController getController() {
        return controller;
    }


    @Override
    public void setObject(Transformable object) {
        controller.setObject(object);
    }


    @Override
    public Transformable getObject() {
        return controller.getObject();
    }


    @Override
    public final void showController() {
        this.setVisible(true);
    }


    @Override
    public void hideController() {
        this.setVisible(false);
    }

}
