package fi.jyu.mit.graphics;

/**
 * Luokka sin-funktion ksittelemiseksi.
 * a*sin(b*x) oletuksen sin(x)
 */
public class SinFun implements FunctionRR {
    /**
     * Luodaan stattinen sini-funktio kaikkien kyttn.
     */
    public static final FunctionRR sin = new SinFun();

    private double a = 1;
    private double b = 1;


    /**
     * Alustetaan oletusarvoilla
     */
    public SinFun() {
        // ei tarvii tehd mitn
    }


    /**
     * Asettaa funktion a*sin(b*x) parametrit a ja b
     * @param a funktion a-parametri
     * @param b funktion b-parametri
     */
    public SinFun(double a, double b) {
        this.a = a;
        this.b = b;
    }


    /**
     * Sinifunktion arvo pisteess x 
     * @param x mist sin lasketaan
     * @return sinin arvo pisteess x
     */
    @Override
    public double f(double x) { 
        return a * Math.sin(b * x);
    }
}