package fi.jyu.mit.graphics;

/**
 * Muunnosmatriisi
 * @author Markus Kivioja
 *
 */
public class TMatrix extends Matrix {

    /**
     * Luo uuden muunnosmatriisin
     *
     */
    public TMatrix() {
        super();
    }


    /**
     * Luo muunnosmatriisi kopion annetusta matriisista
     * @param a kopioitava matriisi
     */
    public TMatrix(Matrix a) {
        super(a);
    }


    /**
     * Luo uuden muunnosmatriisin joka muuntaa RRect nelikulmion SRect nelikulmioksi
     * @param rRect reaalimaailman suorakaide
     * @param sRect nytn suorakaiden johon muunnetaan
     * @param equal onko x/1 aina 1, tosi/eptosi
     */
    public TMatrix(RRect rRect, SRect sRect, boolean equal) {
        super();
        double scale, xs, ys, dxf, dyf, dxt, dyt;
        dxf = rRect.width();
        dyf = rRect.height();
        dxt = sRect.width();
        dyt = sRect.height();
        if (dxf == 0 || dxt == 0)
            xs = 1;
        else
            xs = dxt / dxf;
        if (dyf == 0 || dyt == 0)
            ys = 1;
        else
            ys = dyt / dyf;
        if (equal) {
            scale = Math.abs(xs);
            if (Math.abs(ys) < scale)
                scale = Math.abs(ys);
            xs = Math.abs(xs) / xs * scale;
            ys = Math.abs(ys) / ys * scale;
        }
        this.set(0, 0, xs);
        this.set(1, 1, ys);
        this.set(0, VSIZE - 1, sRect.midX() - rRect.midX() * xs);
        this.set(1, VSIZE - 1, sRect.midY() - rRect.midY() * ys);
    }

    /**
     * Muuntaa 3D-pisteen tll muunnosmatriisilla SPoint-olioksi
     * @param x muunnettavan pisteen x-koordinaatti
     * @param y muunnettavan pisteen y-koordinaatti
     * @param z muunnettavan pisteen z-koordinaatti
     * @return muunnettu piste SPoint-oliona
     */
    /*
     * public SPoint transform(double x, double y, double z) { Vector vr = new
     * Vector(x, y, z);  Vector vs = this.multiply(vr);  SPoint
     * r = new SPoint((int)round(vs.a(0)), (int)round(vs.a(1))); return r; //
     * NOPMD miten muuten voi palauttaa }
     */
    /**
     * Muuntaa RPoint-olion tll muunnomatriisilla SPoint-olioksi
     * @param p muunnettava piste
     * @return muunnettu piste SPoint-oliona
     */
    /*
     * public SPoint transform(RPoint p) { Vector vr = new Vector(p.getX(),
     * p.getY(), p.getZ());  Vector vs = this.multiply(vr); 
     * SPoint r = new SPoint((int)round(vs.a(0)), (int)round(vs.a(1))); return
     * r;  miten muuten voi palauttaa }
     */
}
