package sample;

import fi.jyu.mit.graphics.Axis;
import fi.jyu.mit.graphics.Matrix;
import fi.jyu.mit.graphics.RotMatrix;
import fi.jyu.mit.graphics.TranslateMatrix;
import fi.jyu.mit.graphics.Vector;

/**
 * Testataan miten per�kk�iset kertolaskut toimivat
 * @author vesal
 * @version 31.3.2009
 */
public class MultiplySample {

    /**
     * @param args ei kaytossa
     */
    public static void main(String[] args) {
        Vector u[] = { new Vector(1, 0, 0), new Vector(0, 1, 0),
                new Vector(0, 0, 1) };
        Vector zero = new Vector(0, 0, 0);
        Vector v = new Vector();
        RotMatrix r[] = { new RotMatrix(Axis.Z, 0.0001),
                new RotMatrix(Axis.X, 0.00011),
                new RotMatrix(Axis.Y, 0.00012) };
        Matrix t = new TranslateMatrix(20, 3000, 40000);
        double x = 0, y = 0, z = 0;
        double x0 = 0, y0 = 0, z0 = 0;
        double min = 2, max = 0;
        int n = 10 * 1000 * 1000;
        // double row[] = {0,0,0,0};
        long lahto = System.currentTimeMillis();
        for (int i = 0; i < n; i++) {
            for (RotMatrix rm : r) {
                for (Vector ui : u) {
                    t.multiply(zero, v);
                    x0 = v.a(0);
                    y0 = v.a(1);
                    z0 = v.a(2);
                    t.multiply(ui, v);
                    x = v.a(0) - x0;
                    y = v.a(1) - y0;
                    z = v.a(2) - z0;
                    double l2 = (x * x + y * y + z * z);
                    if (l2 > max)
                        max = l2;
                    if (l2 < min)
                        min = l2;
                }
                // t.multiplyThis(rm,row);
                t.multiplyThis(rm);
            }
        }
        long loppu = System.currentTimeMillis();
        System.out.println("Kierroksia: " + n + " aika: "
                + ((loppu - lahto) / 1000.0) + " s => " + min + " - " + max);

    }

}
